
#ifndef _INTERRUPTIBLE_H_
#define _INTERRUPTIBLE_H_
//-------------------------------------------------------------------------
// INTERRUPTIBLE.H - Interruptible section helper
//
// Copyright (c) 2008 NETGEAR, Inc.
// All rights reserved.
//-------------------------------------------------------------------------

#include <signal.h>

#define INTERRUPTIBLE_SIG	SIGUSR2

struct _interruptible_t;
typedef int (*pinterruptible_handler)(struct _interruptible_t *pintr);

typedef struct _interruptible_t {
    struct interruptible_t *	pnext;
    pinterruptible_handler     	handler;
    void *			refdata;
    int				pid;
    int				signalled;
} interruptible_t;

#define INTERRUPTIBLE_NEVER	((pinterruptible_handler)0)
#define INTERRUPTIBLE_ALWAYS	((pinterruptible_handler)1)
#define INTERRUPTIBLE_DEFAULT	((pinterruptible_handler)2)
#define INTERRUPTIBLE_ALARM	((pinterruptible_handler)3)

int  init_interruptible(void);
int  is_interrupted(void);
int  enter_interruptible(interruptible_t *pintr);
void leave_interruptible(interruptible_t *pintr);
void reset_interruptible(void);
void interrupt_pid(int pid);

#endif // _INTERRUPTIBLE_H_


