/**
 * Filename: file.h
 * 
 * Created by : Dennis J. Aldover (daldover@skipjam.com)
 * 
 * Copyright 2005, SkipJam Inc. All rights reserved
 */

#ifndef _FILE_H_INCLUDED_
#define _FILE_H_INCLUDED_

/**
 * 
 */
typedef struct tagFile
{
 char* fn; // filename
 int h; 
 //FILE* fh; // non-smb
}File, *PtrFile;

#define EXIF_FIO_BUF_SIZE 1024

#ifndef _SJMENUS
#define TRY_ALLOC(p,a,b,c,err) { p=malloc((a*b)); if(!p){ printf("Out of memory\n"); } }
#define TRY_FREE(p,a) { if(p) { free(p); p=0; } }
#define IS_VALID_PTR(p,err) { if(!p) { EXIT_RESULT(err,-1); } }
#define IS_ALLOC_OK(p,err) { if(!p) { printf("Invalid pointer %s - 0x%0x\n", # p, p); EXIT_RESULT(err,-1); } }
#define DBG_PRINT(val,fmt,args...) ((void)(0))
#define DBG_OUTPUT(lvl,val,fmt,args...) ((void)(0))
#define DBG_ENTRY(lvl,fmt,args...) ((void)(0))
#define DBG_EXIT(lvl,fmt,args...) ((void)(0))
#define DBG_INFO(lvl,fmt,args...) ((void)(0))

#define CHECK_RESULT(expr) if( !expr ) { DBG_PRINT( 0, "CHECK_RESULT <%s> Failed\n\tFile: %s\n\tLine: %d\n", #expr, __FILE__, __LINE__ ); goto SAFE_EXIT_HANDLER; }

#define EXIT_RESULT(ret,val) { DBG_INFO( 0xF0000000, "EXIT_RESULT %s = %s \n\tFile: %s\n\tLine: %d\n", #ret, #val, __FILE__, __LINE__ ); ret = val; goto SAFE_EXIT_HANDLER; }

#define EXIT_SAFE() goto SAFE_EXIT_HANDLER

#define EXIT_FAIL(expr) if(FAILED(expr)) { EXIT_SAFE(); }

#define IFFAIL_EXITRESULT(expr,result) if( !expr ) { DBG_INFO( 0xF0000000, "IFFAIL_EXITRESULT(%s)\n", #expr ); return result; }
 
#endif//_SJMENUS

/**
 * 
 */
extern PtrFile ExifFile_( const char* path );
extern void ExifFile__( PtrFile p );
extern int ExifFile_Open( PtrFile p, int flags, mode_t mode );
extern int ExifFile_IsOpen( PtrFile p );
extern void ExifFile_Close( PtrFile p );
extern int ExifFile_Handle( PtrFile p );
extern ssize_t ExifFile_Read( PtrFile p, void* buf, size_t count );
extern ssize_t ExifFile_Write( PtrFile p, const char * buf, size_t count );
extern char* ExifFile_FGets( PtrFile p, char* buf, int n );
extern long long ExifFile_LSeek( PtrFile p, off_t offset, int mode );
extern long long ExifFile_GetSize( PtrFile p );
extern const char* ExifFile_GetProtocol( PtrFile p );

#endif //_FILE_H_INCLUDED_
