/*
 * include/asm-arm/arch-em86xx/board-generic/mtdpartitions.h
 *
 * Copyright (C) 2003-2004 Sigma Designs, Inc
 * 
 * Sigma Designs Evaluation Boards
 */

#ifndef __ASM_ARCH_BOARD_MTDPARTITIONS_H
#define __ASM_ARCH_BOARD_MTDPARTITIONS_H

#include <asm/arch/boardname.h>

#ifdef CONFIG_MTD_PARTITIONS

//        size: EM86XX_FLASH_SIZE - (0x10000+0x20000+EM86XX_GZ_KERNEL_SIZE), 

#define EM86XX_FLASH_SIZE (8*1024*1024)

//#define EM86XX_GZ_KERNEL_SIZE (1664)*1024
//#define EM86XX_GZ_KERNEL_SIZE (1728)*1024
//#define EM86XX_GZ_KERNEL_SIZE (1792)*1024
#define EM86XX_BOOT_SIZE         (64*1024)
#define EM86XX_2NDBOOT_SIZE     (128*1024)
#define EM86XX_GZ_KERNEL_SIZE   (960*1024)
#define EM86XX_CRAMFS_SIZE     (6464*1024)
#define EM86XX_JFFS2_SIZE       (512*1024)
#define EM86XX_RESERVED_SIZE     (64*1024)

#define EM86XX_BOOT_OFFSET       (0x0)
#define EM86XX_2NDBOOT_OFFSET    (EM86XX_BOOT_OFFSET+EM86XX_BOOT_SIZE)
#define EM86XX_GZ_KERNEL_OFFSET  (EM86XX_2NDBOOT_OFFSET+EM86XX_2NDBOOT_SIZE)
#define EM86XX_CRAMFS_OFFSET     (EM86XX_GZ_KERNEL_OFFSET+EM86XX_GZ_KERNEL_SIZE)
#define EM86XX_JFFS2_OFFSET      (EM86XX_CRAMFS_OFFSET+EM86XX_CRAMFS_SIZE)
#define EM86XX_RESERVED_OFFSET   (EM86XX_JFFS2_OFFSET+EM86XX_JFFS2_SIZE)

#define EM86XX_MTD_PARTITIONS \
    { /* 64KB readonly: first stage bootloader, read-only */ \
        name: "BootROM1", \
        size: EM86XX_BOOT_SIZE, \
        offset: EM86XX_BOOT_OFFSET, \
        mask_flags: MTD_WRITEABLE, \
    }, \
    { /* 128KB: second stage bootloader, read-only */ \
        name: "BootROM2", \
        size: EM86XX_2NDBOOT_SIZE, \
        offset: EM86XX_2NDBOOT_OFFSET, \
        mask_flags: MTD_WRITEABLE, \
    }, \
    { /* Partition for Kernel, read-only */ \
        name: "GZKernel", \
        size: EM86XX_GZ_KERNEL_SIZE, \
        offset: EM86XX_GZ_KERNEL_OFFSET, \
        mask_flags: MTD_WRITEABLE, \
    }, \
    { /* 5504KB CRAMFS, read only */ \
        name: "CRAMFS", \
        size: EM86XX_CRAMFS_SIZE, \
        offset: EM86XX_CRAMFS_OFFSET, \
        mask_flags: MTD_WRITEABLE, \
    }, \
    { /* 512KB JFFS2 read/write */ \
        name: "JFSS2", \
        size: EM86XX_JFFS2_SIZE, \
        offset: EM86XX_JFFS2_OFFSET, \
        mask_flags: 0, \
    },
#endif

#endif
